CoolWatchData = {}
CoolWatchDataID = {}
CoolWatchWatched = {}
CoolWatchWatchedID = {}
CoolWatchWatchedState = {}
CoolWatch_Initialised = 0
CoolWatch_UpdateTimer = 0
CoolWatch_UpdatePause = 0.5

local nSpells = 0
local nWatched = 0

function CoolWatch_OnLoad()
	this:RegisterForDrag("LeftButton");
	this:RegisterEvent("VARIABLES_LOADED")

	COOL_MSGTEXT:SetHeight(64) ;
	COOL_MSGTEXT:Show();
	COOL_MSGTEXT:SetPoint("CENTER", "UIParent", "CENTER", 0.0, 256.0);
	COOL_MSGTEXT:SetTimeVisible(5.0);
	COOL_MSGTEXT:SetFadeDuration(1);

	this:Hide()
end

function CoolWatch_OnUpdate()
	if(CoolWatch_Initialised > 1) then
		local _CurrentTime = GetTime()
		if (_CurrentTime >= CoolWatch_UpdateTimer) then
			CoolWatch_UpdateTimer = (_CurrentTime + CoolWatch_UpdatePause)

			local i
			for i=1,nWatched do
				local start, duration = GetSpellCooldown(CoolWatchWatchedID[i], "BOOKTYPE_SPELL");
				if(duration > 2) then
					if(CoolWatchWatchedState[i] == 0)then
--	DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."CoolWatch v0.1: Detected cooldown: "..CoolWatchWatched[i]..", id="..CoolWatchWatchedID[i].." start="..start..", Dur ="..duration)
						CoolWatchWatchedState[i] = 1
					end
				else
					if(CoolWatchWatchedState[i] ~= 0) then
						-- COOLDOWN ENDED since last update
						CoolWatch_Message( CoolWatchWatched[i].." Cooldown has expired!",1,0.5,0.5)
						CoolWatchWatchedState[i] = 0
					end
				end
			end
 		end
	elseif(CoolWatch_Initialised > 0) then
		-- Spellbook is initialised after us (bah!)
		CoolWatch_ReadSpellbook()
	end
end

function CoolWatch_ReadSpellbook()
	local id = 1
	nSpells = 0
	while true do
		local spellName, spellRank = GetSpellName(id, BOOKTYPE_SPELL)
		if not spellName then
			do break end
		end

		if( spellName ~= CoolWatchData[nSpells] ) then
			nSpells = nSpells + 1
			CoolWatchData[nSpells] = spellName
			CoolWatchDataID[nSpells] = id
--DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."CoolWatch v0.1: adding: "..CoolWatchData[nSpells]..", id="..CoolWatchDataID[nSpells])
		end
		id = id + 1
	end

	if(nSpells < 2) then
		return
	end

	-- Yay, spellbook is initialised!
	CoolWatch_Initialised = 2

	nWatched = table.getn(CoolWatchWatched)
	-- Now run through 'watched' finding ID's
	if(nWatched > 0) then
		local i,j
		for i=1,nWatched do
			CoolWatchWatchedState[i] = 0	-- Set to 'no cooldown'
			for j=1,nSpells do
				if( CoolWatchWatched[i] == CoolWatchData[j] ) then
					CoolWatchWatchedID[i] = CoolWatchDataID[j]
					break
				end
			end	
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."CoolWatch v0.1: watching "..nWatched.." spells.")
	DEFAULT_CHAT_FRAME:AddMessage("|c0033CCFF".."   '/coolwatch' or '/cw' for options")

	CoolWatchScrollBar:Show()
	CoolWatch2ScrollBar:Show()
end

function CoolWatch_Event()
    if(event == "VARIABLES_LOADED") then
		CW_Slider:SetValue(CoolWatchTextHeight)
		COOL_MSGTEXT:SetPoint("CENTER","UIParent","CENTER",0,CoolWatchTextHeight)
		if( CoolWatchWatched["hasRun"] == nil )then
			-- First time of running
			this:Show()
			CoolWatchWatched["hasRun"] = 1
		end

		CoolWatch_Initialised = 1
    end
end

function CoolWatchScrollBar_Update()
	local line;
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	local barCount = 8
	if(nSpells < 8) then
		barCount = nSpells
	end
	FauxScrollFrame_Update(CoolWatchScrollBar,nSpells,barCount,16);
	for line=1,8 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(CoolWatchScrollBar);
		if lineplusoffset <= nSpells then
			getglobal("CoolWatchEntry"..line.."_Text"):SetText(CoolWatchData[lineplusoffset]);
			getglobal("CoolWatchEntry"..line):Show();
		else
			getglobal("CoolWatchEntry"..line):Hide();
		end
	end
end

function CoolWatch2ScrollBar_Update()
	local line;
	local lineplusoffset; -- an index into our data calculated from the scroll offset
	local barCount = 8
	if(nWatched < 8) then
		barCount = nWatched
	end
	FauxScrollFrame_Update(CoolWatch2ScrollBar,nWatched,barCount,16);
	for line=1,8 do
		lineplusoffset = line + FauxScrollFrame_GetOffset(CoolWatch2ScrollBar);
--DEFAULT_CHAT_FRAME:AddMessage( "CW: nWatched = "..nWatched )
		if lineplusoffset <= nWatched then
			getglobal("CoolWatch2Entry"..line.."_Text"):SetText(CoolWatchWatched[lineplusoffset]);
			getglobal("CoolWatch2Entry"..line):Show();
		else
			getglobal("CoolWatch2Entry"..line):Hide();
		end
	end
end

function CoolWatch_Click()
	local entry
	local buttonID = this:GetID()
	if(buttonID < 10) then
		-- Input scrollbar
		entry = buttonID + FauxScrollFrame_GetOffset(CoolWatchScrollBar);
		if(entry <= nSpells) then
			CoolWatch_AddWatched(entry)
		end
	else
		-- Watched Scrollbar
		buttonID = buttonID - 10
		entry = buttonID + FauxScrollFrame_GetOffset(CoolWatch2ScrollBar);
		if(entry <= nWatched) then
			CoolWatch_RemoveWatched(entry)
		end
	end
end

function CoolWatch_AddWatched(n)
	local i
	if (nWatched > 0) then
		for i=1,nWatched do
			if( CoolWatchWatched[i] == CoolWatchData[n] ) then
				return
			end
		end
	end

	nWatched = nWatched + 1
	CoolWatchWatched[nWatched] = CoolWatchData[n]
	CoolWatchWatchedID[nWatched] = CoolWatchDataID[n]
	CoolWatchWatchedState[nWatched] = 0

	CoolWatch2ScrollBar_Update()
--	DEFAULT_CHAT_FRAME:AddMessage( "CoolWatch: Now watching '"..CoolWatchData[n].." (id="..CoolWatchDataID[n]..")" )
end

function CoolWatch_RemoveWatched(n)
	local i
--	DEFAULT_CHAT_FRAME:AddMessage( "CoolWatch: STOPPED watching '"..CoolWatchWatched[n].." (id="..CoolWatchWatchedID[n]..")" )
	for i=n+1,nWatched do
		CoolWatchWatched[i-1] = CoolWatchWatched[i]
		CoolWatchWatchedID[i-1] = CoolWatchWatchedID[i]
		CoolWatchWatchedState[i-1] = CoolWatchWatchedState[i]
	end
	CoolWatchWatched[nWatched] = nil
	nWatched = nWatched - 1
	CoolWatch2ScrollBar_Update()
end

function CoolWatch_Message(msg, r, g, b)
	COOL_MSGTEXT:AddMessage(msg, r, g, b);
end

function CoolWatch_OnDragStart(Frame)
	Frame:StartMoving()
end

function CoolWatch_OnDragStop(Frame)
	Frame:StopMovingOrSizing()
end

CoolWatchTextHeight = 0

function CW_SliderChanged(frame)
	if(CoolWatch_Initialised > 0) then
		CoolWatchTextHeight = CW_Slider:GetValue()
		COOL_MSGTEXT:SetPoint("CENTER","UIParent","CENTER",0,CoolWatchTextHeight)
		COOL_MSGTEXT:AddMessage("CoolWatch Message will appear HERE!", 1,1,1);
	end
end




---- SLASH COMMANDS ----
function CoolWatch_Show()
	getglobal("CoolWatch"):Show()
end

SLASH_COOLWATCH1 = "/coolwatch"
SLASH_COOLWATCH2 = "/cw"
SlashCmdList["COOLWATCH"] = CoolWatch_Show;
